#include "config.h"

# include <string.h>
# include <ctype.h>
# include <math.h>
# include <stdio.h>

struct station  {
        char call[10];
	char RSTgeg[10];
	char RSTerh[10];
	char locator[10];
	char UTC[10];
	int Dist;
	struct station * p_to_next;
	};
                                                                
struct station Station;

struct list {
	char field[4];
	struct list * p_to_next;
	};
	
struct list List;

struct header{
	struct list *front;
	struct list *now;
	struct list *back;
	};

struct header Header;
	
int alt(FILE *ein_ptr,FILE *aus_ptr);

int nummer=1;
int gesamt=0;
int anzahl;
int best=0;
int fieldnr=0;
char call[10],myloc[6],name[256];
int wertnr,day,month,year;



/*******************************************************************/
/*              here the main programs starts !!!!!                */
/*******************************************************************/

int
main(int argc, char *argv[])
{

	FILE *ein_ptr;
	FILE *aus_ptr;
	
	if (--argc > 0) {

	char contestname[30],myname[125],licence[3],dok[5],street[30];
	char plz[20],vv[10],rx[20],tx[20],em[3], antenne[20];
	int watt, country, height, nn; 
/******************************************************************/    
/*****  if the infile already exists, open and read it,       *****/
/*****  else create a new one !!!                             *****/
/******************************************************************/
	        ein_ptr=fopen("myloc","r");
	        if(ein_ptr!=NULL)           
			fscanf(ein_ptr,"%s",myloc);             
		else
		{
			printf("create file 'myloc' with your locator !\n");
			exit(0);
		}
		fclose(ein_ptr);

	        ein_ptr=fopen("auswert.conf","r");
	        if(ein_ptr!=NULL){           
			fgets(contestname,30,ein_ptr);
			fscanf(ein_ptr,"%d \n %d \n %d \n %d \n",&day,&month,&year,&wertnr);
			fgets(call,10,ein_ptr);
			fgets(licence,5,ein_ptr);
			fgets(dok,5,ein_ptr);
			fscanf(ein_ptr,"%d\n",&country);
			fgets(em,3,ein_ptr);
			fgets(myname,125,ein_ptr);
			fgets(street,30,ein_ptr);
			fgets(plz,30,ein_ptr);
			fgets(tx,20,ein_ptr);
			fgets(rx,20,ein_ptr);
			fscanf(ein_ptr,"%d \n",&watt);
			fgets(vv,10,ein_ptr);
			fgets(antenne,20,ein_ptr);
			fscanf(ein_ptr,"%d \n %d \n",&height,&nn);
		}				
		else
		{
			printf("create file 'auswert.conf' !\n");
			exit(0);
		}
		fclose(ein_ptr);

	     	strcpy(name,argv[1]);
     		strcat(name,".tex");
     	
     		aus_ptr=fopen(name,"w");
		
		fprintf(aus_ptr,"\\documentclass{article} \n");
		fprintf(aus_ptr,"\\usepackage{a4,german} \n");
		fprintf(aus_ptr,"\\textheight25cm \n\\topmargin-10mm \n\\topskip0mm \n");
		fprintf(aus_ptr,"\\parindent0mm \n");
		fprintf(aus_ptr,"\\pagestyle{myheadings}\\markright{Rufzeichen: %s \\hfill Locator: %s \\hfill Wertungsgruppe: %d \\hfill Seite: \\hfill} \n",call,myloc,wertnr);
		fprintf(aus_ptr,"\\begin{document} \n");
		fprintf(aus_ptr,"\\begin{center} \n");
		fprintf(aus_ptr,"\\begin{tabular}{|l|l|l|l|l|l|l|} \\hline\n");
		fprintf(aus_ptr,"Datum&Zeit UTC&Call&$RST_{geg}$&$RST_{erh}$&Locator&Punkte \\\\ \\hline\n");
		
		ein_ptr=fopen(argv[1],"r");
		if(ein_ptr!=NULL)           
			nummer = alt(ein_ptr,aus_ptr);
		else
			nummer = 1;
		fclose(ein_ptr);

		fprintf(aus_ptr,"\\multicolumn{6}{r}{Gesamtkilometer:}&\\multicolumn{1}{l}{%d}\\\\ \n",gesamt);
		fprintf(aus_ptr,"\\multicolumn{6}{r}{Durchschnitt:}&\\multicolumn{1}{l}{%d}\\\\ \n",gesamt/nummer);
		fprintf(aus_ptr,"\\end{tabular} \n");
		fprintf(aus_ptr,"\\end{center} \n");

		fprintf(aus_ptr,"\\begin{titlepage} \n");
		fprintf(aus_ptr,"{\\huge DARC VHF-, UHF-, SHF-WETTBEWERB} \n\n\\vspace{1cm} \n");
		fprintf(aus_ptr,"Wettbewerb: \\underline{%s} \\hfill Datum \\underline{%d./%d.%d.%d}\\\\ \n\n",contestname,day-1,day,month,year);
		fprintf(aus_ptr,"\\begin{tabular}{lrlr} \n");
		fprintf(aus_ptr,"Wertungsgruppe laut Wettbewerbsregeln & \\fbox{%d} &Rufzeichen & \\fbox{%s} \\\\ \n",wertnr,call);
		fprintf(aus_ptr,"Lizenzklasse (A,B,C) & \\fbox{%s} & DOK & \\fbox{%s} \\\\ \n",licence,dok);
		fprintf(aus_ptr,"Gearbeitete Locator-Gro\"sfelder & \\fbox{%d}&Locator& \\fbox{%s} \\\\ \n",fieldnr,myloc);
		fprintf(aus_ptr,"Gearbeitete L\"ander&\\fbox{%d}&Ein-,Mehrmannbetrieb(E,M) &\\fbox{%s} \\\\ \n",country,em);
		fprintf(aus_ptr,"Punkte pro Verbindung& \\fbox{%d} &Gewertete Verbindungen & \\fbox{%d} \\\\ \n",gesamt/nummer,nummer);
		fprintf(aus_ptr,"Weiteste Verbindung (km)&\\fbox{%d}&Gesamtpunktzahl&\\fbox{%d}\\\\ \n \\\\ \n",best,gesamt);  
		fprintf(aus_ptr,"\\end{tabular} \n\\vspace{2mm}\n\n");
		fprintf(aus_ptr,"\\underline{\\hspace{9cm}}\\ \\underline{\\hspace{2cm}}\\ \\underline{\\hspace{3cm}}\\\\ \n \\\\ \n");
		fprintf(aus_ptr,"\\underline{\\hspace{9cm}}\\ \\underline{\\hspace{2cm}}\\ \\underline{\\hspace{3cm}}\\\\ \n \\\\ \n");
		fprintf(aus_ptr,"\\underline{\\hspace{9cm}}\\ \\underline{\\hspace{2cm}}\\ \\underline{\\hspace{3cm}}\\\\ \n \\\\ \n");
		fprintf(aus_ptr,"Anschrift des verantwortlichen Funkamateurs: \\\\ \n\\\\ \n");
		fprintf(aus_ptr,"\\begin{tabular}{ll} \n");
		fprintf(aus_ptr,"Name :&\\fbox{%s} \\\\ \n",myname);
		fprintf(aus_ptr,"Stra\"se :&\\fbox{%s} \\\\ \n",street);
		fprintf(aus_ptr,"PLZ Ort :&\\fbox{%s} \\\\ \n",plz);
		fprintf(aus_ptr,"\\end{tabular}\\\\ \n \n");
		fprintf(aus_ptr,"Angaben zur verwendeten Station:\\\\ \n\\\\ \n");
		fprintf(aus_ptr,"\\begin{tabular}{llll}\nSender & \\underline{%s} & Ausgangsleistung & \\underline{%d} W \\\\ \n",tx,watt);
		fprintf(aus_ptr,"Empf\"anger & \\underline{%s} & Eingangsstufe & \\underline{%s} \\\\ \n",rx,vv);             
		fprintf(aus_ptr,"\\end{tabular} \n\\\\ \n\n");
		fprintf(aus_ptr,"Antenne \\underline{%s}  \"uber Grund \\underline{%d} m, \"uber NN \\underline{%d} m \\\\ \n\\\\ \n",antenne,height,nn);
		fprintf(aus_ptr,"Ich best\"atige, da\"s die Lizenzbestimmungen und die Wettbewerbsregeln eingehalten wurden \\\\ \n\\vspace{2mm}\n\n");
		fprintf(aus_ptr,"\\parbox[t]{5cm}{Verantwortlicher Funkamateur:\\\\ \\\\ Beteiligte Funkamateure:}\n");
		fprintf(aus_ptr,"\\parbox[t]{10cm}{\n \\underline{\\hspace{2cm}}   \\underline{\\hspace{5cm}} \\\\ \\\\ \n");
		fprintf(aus_ptr,"\\underline{\\hspace{2cm}}   \\underline{\\hspace{5cm}} \\\\ \\\\ \n");
		fprintf(aus_ptr,"\\underline{\\hspace{2cm}}   \\underline{\\hspace{5cm}} \\\\ \\\\ \n");
		fprintf(aus_ptr,"\\underline{\\hspace{2cm}}   \\underline{\\hspace{5cm}} \\\\ \\\\ \n");
		fprintf(aus_ptr,"\\underline{\\hspace{2cm}}   \\underline{\\hspace{5cm}} \\\\ \n");
		fprintf(aus_ptr,"Rufzeichen \\hspace{2cm} Unterschrift \n}\n");
		   
		fprintf(aus_ptr,"\\end{titlepage} \n");
		
		fprintf(aus_ptr,"\\end{document} \n");

		fclose(aus_ptr);		

		printf("total kilometer  : %d \naverage kilometer: %d \n",gesamt,gesamt/nummer);
		
		exit(0);
	}
	else
	{
		printf("usage: auswert {logfile}\n");
		exit(1);
	}
}


/*******************    read existing file   **************/

int alt(FILE *ein_ptr, FILE *aus_ptr)
{
int numm,seitenumbruch=0,time,lasttime=0,i;
char nullen[3],stime[3];
struct list *hold;

	Header.back=(struct list *) calloc(1,sizeof(struct list));
	Header.now=Header.back;
	Header.front=Header.back;

 
	while((fscanf(ein_ptr,"%d %s %s %s %s %s %d \n",&numm,Station.call, \
		Station.RSTgeg, \
		Station.RSTerh, \
		Station.locator, \
		Station.UTC, \
		&Station.Dist)) \
		!=EOF)
	{ 
		if(numm<10)
			strcpy(nullen,"00");
		else	
			if(numm<100)
				strcpy(nullen,"0");
		if(numm>=100)
			strcpy(nullen," ");
		
		strncpy(stime,Station.UTC,2);
		time=atoi(stime);		
		if(time < lasttime) ++day;
		lasttime=time;
		
		if(best<Station.Dist) best=Station.Dist;
		
		i=0;				
		Header.now=Header.front;
		while((strncmp(Header.now->field,Station.locator,4))&&(i<(fieldnr))&&(numm>1)){
			hold=Header.now->p_to_next;
			Header.now=hold;
			i++;
		}
		if(i==(fieldnr)){
			Header.back=(struct list *) calloc(1,sizeof(struct list));
			Header.now->p_to_next=Header.back;
			strncpy(Header.back->field,Station.locator,4);
			fieldnr++;
			printf("%d %s \n",fieldnr,Header.back->field);
		}
			
		fprintf(aus_ptr,"%d.%d.%d & %s & %s & %s%s%d & %s & %s & %d %s \n", \
		day,month,year, \
		Station.UTC, \
		Station.call, \
		Station.RSTgeg,nullen,nummer, \
		Station.RSTerh, \
		Station.locator, \
		Station.Dist,\
		"\\\\ \\hline");
		if(seitenumbruch==49){
			fprintf(aus_ptr,"\\multicolumn{6}{r}{Summe:}&\\multicolumn{1}{l}{%d}\\\\ \n",gesamt);
			fprintf(aus_ptr,"\\end{tabular} \n");
			fprintf(aus_ptr,"\\newpage \n");
			fprintf(aus_ptr,"\\begin{tabular}{|l|l|l|l|l|l|l|} \\hline \n");
			fprintf(aus_ptr,"Datum&Zeit UTC &Call&$RST_{geg}$&$RST_{erh}$&Locator&Punkte \\\\ \\hline\n");
			fprintf(aus_ptr,"\\multicolumn{6}{|r|}{\"Ubertrag:}&\\multicolumn{1}{|l|}{%d}\\\\ \\hline\n",gesamt);

			seitenumbruch=0;
			}
		else
			seitenumbruch++;
		
		gesamt=gesamt+Station.Dist;
		nummer++;	

	}
	return numm;
}
