#include "config.h"

# include <curses.h>        /* maybe change this to the exact path */
# include <string.h>
# include <ctype.h>
# include <time.h>
# include <math.h>

float length, width;
double l1,l2,b1,b2,em;
time_t nowtimer;
char myloc[6];
WINDOW *MainWin, *NrWin1, *NrWin2, *NrWin3, *CompWin, *StatusWin;
	
struct station  {
	char call[10];
	char RSTout[10];
	char RSTin[10];
	char locator[10];
	char UTC[10];
	int Dist;
	struct station * p_to_next;
	};

struct station Station;

struct ok{
	int call;
	int RSTout;
	int RSTin;
	int locator;
	int UTC;
	};		

struct ok Ok;

struct header{
                struct station *front;
                struct station *now;
                struct station *back;
	};
                                                        
struct header Header;

void WinInit();
struct station Input(WINDOW *MainWin,WINDOW *CompWin);
int reader(WINDOW *Window,int y,int x,int i,char *str,int max,int min, int rule,WINDOW *CompWin);
void timer(char *s);
int alt(FILE *ein_ptr,WINDOW *MainWin, int *total);
void convert(char *s);
void homedates(char *s);
void otherstation(char *s);
double distance();
double direction();
void Compare(WINDOW *Window,char *l,int ziff,struct station *p_to_s);
void vLine(int x1,int x2,int y,char *s);
void hLine(int x,int y1,int y2,char *s);
void kilometers(WINDOW *Window, int total, int number);
void printnr(WINDOW *Window1, WINDOW *Window2, WINDOW *Window3, int s);
void assign(char *s, int i);
void number2win(WINDOW *Window,char *s);

int nummer=0;

#define one "\n    /|\n   / |\n  /  |\n     |\n     |\n     |\n"
#define two " __\n/  \\\n    |\n   /\n  /\n /\n-----\n"
#define three " __\n/  \\\n    |\n   /\n   \\\n    |\n\\__/\n"
#define four "\n  /\n / |\n/__|__\n   |\n   |\n   |\n"
#define five "____\n|\n|\n|__\n   \\\n    |\n___/\n"
#define six "  __\n /  \\\n|\n|___\n|   \\\n|    |\n \\__/\n"
#define seven "______\n     /\n    /\n   /\n  /\n /\n/\n"
#define eight "  __\n /  \\\n|    |\n \\__/\n /  \\\n|    |\n \\__/\n"
#define nine "  __\n /  \\\n|    |\n \\___|\n     |\n     |\n \\__/\n"
#define zero "  __\n /  \\\n|    |\n|    |\n|    |\n|    |\n \\__/\n" 

/*******************************************************************/
/*              Here the main Program begins !!!!!                 */
/*******************************************************************/

int
main(int argc, char *argv[])
{
	if (--argc > 0) {
	int raus,total=0;
	FILE *ein_ptr;

	initscr();
	cbreak();
	noecho();

	MainWin = newwin(6,78,13,1);
	NrWin1 = newwin(9,7,1,1);
	NrWin2 = newwin(9,7,1,9);
	NrWin3 = newwin(9,7,1,17);
	CompWin = newwin(9,54,1,25);
	StatusWin = newwin(3,78,21,1);

	idlok(MainWin,TRUE);
	scrollok(MainWin,TRUE);
	scrollok(CompWin,TRUE);

	
	ein_ptr=fopen("myloc","r");
		if(ein_ptr!=NULL)           
			fscanf(ein_ptr,"%s",myloc);		
		else
		{
			printf("create file 'myloc' with your locator !\n");
			exit(0);
		}
		fclose(ein_ptr);


/* calculates once the necessary parameters for the subroutines */
/* distance and direction */

	homedates(myloc);  
	
	WinInit();                /* Hintergrund-Linien,Ueberschriften */

	Header.back=(struct station *) calloc(1,sizeof(struct station));
	Header.now=Header.back;
	Header.front=Header.back;

/******************************************************************/	
/*****  if the infile already exists, open and read it,       *****/
/*****  else create a new one !!!                             *****/
/******************************************************************/
    	
		ein_ptr=fopen(argv[1],"r");
		if(ein_ptr!=NULL){
			nummer = alt(ein_ptr,MainWin, &total);
			kilometers(StatusWin,total,nummer);
		}
		else
			nummer = 0;
		fclose(ein_ptr);
		
		ein_ptr=fopen(argv[1],"a");   /** open to append **/

		do {
			nummer++;
			mvwprintw(MainWin,5,1,"%3d",nummer);
			wrefresh(MainWin);
			
			printnr(NrWin1,NrWin2,NrWin3,nummer);
			
			*Header.now=Input(MainWin,CompWin);
			scroll(MainWin);
	
			total=total+Header.now->Dist;
	
			raus=strncmp(Header.now->call,"QUIT",4);
			if (raus){ 
				kilometers(StatusWin,total,nummer);

				fprintf(ein_ptr,"%d %s %s %s %s %s %d \n", \
				nummer,Header.now->call, \
				Header.now->RSTout, \
				Header.now->RSTin, \
				Header.now->locator, \
				Header.now->UTC, \
				Header.now->Dist);
			
				Header.back=(struct station *) calloc(1,sizeof(struct station));
				Header.now->p_to_next=Header.back;
				Header.now=Header.back;
			}
			
		}
		while (raus);
		
 	clear();
	refresh();
	endwin();
	fclose(ein_ptr);
	exit(0);
	}
	else
	{
		printf("usage: contest {filename} \n");
		exit(1);
	}
}

/****************************************************/
/*                   INPUT                          */
/****************************************************/

struct station Input(WINDOW *MainWin,WINDOW *CompWin)
{

struct station S;
char s[10];
struct ok K;
int komplett = 0;

K.call=0;
K.RSTin=0;
K.RSTout=0;
K.locator=0;

#define inputline 5

     do{
     	K.call=reader(MainWin,inputline,8,K.call,S.call,8,4,0,CompWin);
	if (!strncmp(S.call,"QUIT",4))
		return S;
	K.RSTout=reader(MainWin,inputline,21,K.RSTout,S.RSTout,3,2,1,CompWin);
	K.RSTin=reader(MainWin,inputline,31,K.RSTin,S.RSTin,6,5,3,CompWin);
	K.locator=reader(MainWin,inputline,41,K.locator,S.locator,6,6,2,CompWin);
	if (K.locator==6){

/* Print distance and direction */
/* differ between QTH=myloc, cause else problems appear with division by zero */

	mvwprintw(MainWin,inputline,64,"            ");			
	if(strncmp(myloc,S.locator,6)){
		otherstation(S.locator);
		S.Dist=distance();
		mvwprintw(MainWin,inputline,64,"%d",S.Dist);
		mvwprintw(MainWin,inputline,73,"%.0f",direction());			
	}
	else{
		S.Dist=1;
		mvwprintw(MainWin,inputline,64,"1");
		mvwprintw(MainWin,inputline,73,"0");			
	}		
	}
     
  	if((K.call >= 4) && (K.RSTout >= 2) && (K.locator == 6) && (K.RSTin >= 5))
  		komplett=1;
     }	
     while(komplett == 0);			
	
	timer(s);
	strcpy(S.UTC,s);
	mvwprintw(MainWin,inputline,54,S.UTC);


	return S;		
}

/*************************************************************************/
/********************      read letters     ******************************/
/*************************************************************************/

int reader(WINDOW *Window,int y,int x,int i,char *l,int max, int min, int rule,WINDOW *CompWin)
{
int ok;

	wmove(Window,y,x+i);
	wrefresh(Window);
	noecho(); 
	
	while (((l[i]=mvwgetch(Window,y,x+i)) != '\n') && (i<=max) )
	{


	    if ( islower(l[i]) || isspace(l[i]) || isdigit(l[i]) || (l[i] == '/') || (l[i] == '\b') || (l[i] =='\177')){
		if ((l[i] == '\b') || (l[i] == '\177')) {
		
		/* Unterscheidung, da '\b' nur unter X funktionierte */
		
		    if (i>0) {
			mvwaddch(Window,y,x+i-1,' ');
			wmove(Window,y,x+i-1);
			i--;
		    }
		} 
		else if (i<max){

/***********************    control for correct input   *******************/

			ok = FALSE;
			if ( rule == 0)
				ok = TRUE;
				
					
					
			if ( (rule == 1) && (isdigit(l[i]))) {
				if ((i==0) && (atoi(&l[i])<6) && (atoi(&l[i])>0))
					ok = TRUE;
				if ((i>0) && (atoi(&l[i])>0))
					ok = TRUE;
			}
			if (rule == 2){
				if ((i>=0) && (i<2) && (islower(l[i])))
					ok = TRUE; 
				if ((i>1) && (i<4) && (isdigit(l[i])))
					ok = TRUE;
				if ((i>3) && (i<6) && (islower(l[i])))
					ok = TRUE;	
			}
			if ( (rule == 3) && (isdigit(l[i]))) {
				if ((i==0) && (atoi(&l[i])<6) && (atoi(&l[i])>0))
					ok = TRUE;
				if ((i==1) && (atoi(&l[i])>0))
					ok = TRUE;	
				if (i>1)
					ok = TRUE;			
			}
			if ( ok ) {
				l[i]=toupper(l[i]);
				mvwaddch(Window,y,x+i,l[i]);
				i++;
			}
			
/*********************** compare if callsign has already been work ***********/

	 	}
	 	wrefresh(Window);
	     }
		if ((rule==0) && (i>2))
			Compare(CompWin,l,i,Header.front);
		else{
			wclear(CompWin);
			wrefresh(CompWin);
		} 	
		wrefresh(Window);	
	}
     	if (i >= min)
     		l[i]='\0';
     
	
	noecho();
	return i;
}

/************************  time   ****************************/

void timer(char *s)
{
	nowtimer = time(NULL);
	strftime(s,20,"%H:%M", localtime(&nowtimer));
}

/*******************    read existing infile   **************/

int alt(FILE *ein_ptr,WINDOW *MainWin, int *total)
{
int nummer,numm;
nummer = 1;
*total=0;

	while((fscanf(ein_ptr,"%d %s %s %s %s %s %d \n",&numm,Header.now->call, \
		Header.now->RSTout, \
		Header.now->RSTin, \
		Header.now->locator, \
		Header.now->UTC, \
		&Header.now->Dist)) \
		!=EOF)
	{ 
		mvwprintw(MainWin,5,1,"%3d",numm);
		mvwprintw(MainWin,5,8,Header.now->call);
		mvwprintw(MainWin,5,21,Header.now->RSTout);
		mvwprintw(MainWin,5,31,Header.now->RSTin);
		mvwprintw(MainWin,5,41,Header.now->locator);
		mvwprintw(MainWin,5,54,Header.now->UTC);
		mvwprintw(MainWin,5,64,"%d",Header.now->Dist);
		scroll(MainWin);
		wrefresh(MainWin);
		nummer++;	
		*total=*total+Header.now->Dist;

		Header.back=(struct station *) calloc(1,sizeof(struct station));
		Header.now->p_to_next=Header.back;
		Header.now=Header.back;
		
		
	}
	return numm;
}

/*****************************************************************************/
/********    calculation of distance and direction: source CQ/DL 12-85 S.699 */
/*****************************************************************************/


void homedates(char *s)
{
	convert(s);
	l1=length/180.0*PI;
	b1=width/180.0*PI;
}

void otherstation(char *s)
{	
	convert(s);
	l2=length/180.0*PI;
	b2=width/180.0*PI;
}

double distance()
{
	double ac,en;
	ac=cos(fabs(l1-l2))*cos(b1)*cos(b2)+sin(b1)*sin(b2);
	en=-atan(ac/sqrt(1-pow(ac,2)))+PI/2.0;
	em=en;
	en=en*6368.0;
	en=en+0.5;
	return(en);
}	

double direction()
{
	double si,ri;	
	si=cos(b1)*sin(fabs(l1-l2))/sin(em);
	ri=atan(si/sqrt(1-pow(si,2)))*180.0/PI;
	if ((l2>l1) && (b2<b1))
		ri=180.0-ri;
	if ((l2<=l1) && (b2<=b1))
		ri=180.0+ri;
	if ((l2<l1) && (b2>b1))
		ri=360.0-ri;
	ri=ri+0.5;
	return(ri);	
	
}
		
void convert(char *s)
{
int a,b,c,d,ee,ff;
float e,f;
	a=(s[0]-65)*20+180;
		if (a>360)
			a=a-360;
	b=(s[1]-65)*10-90;
	c=(s[2]-48)*2;
	d=(s[3]-48);
	ee=(s[4]-65);
	e=ee*(5.0/60)+(2.5/60);
	ff=(s[5]-65);
	f=ff*(2.5/60)+(1.25/60);
	length=a+c+e;
	width=b+d+f;
}

/**********************************************************************/
/**************** compare if callsign has already been work ***********/
/**********************************************************************/

void Compare(WINDOW *Window,char *l,int ziff,struct station *p_to_s)
{
	int i;
	struct station *hold;
	wclear(Window); 
	wrefresh(Window);
	for(i=0;i<(nummer-1);i++){
		if (!strncmp(l,p_to_s->call,ziff)){
			scroll(Window);
			mvwprintw(Window,8,4,"%d",(i+1));
			mvwprintw(Window,8,11,"%s",p_to_s->call);
			mvwprintw(Window,8,23,"%s",p_to_s->locator);
			mvwprintw(Window,8,38,"%s",p_to_s->RSTin);
			
		}
		hold=p_to_s->p_to_next;
		p_to_s=hold;
	}
	wrefresh(Window);
}

/***********************************************************************/
/******  create text and lines for the windows in the background  ******/
/***********************************************************************/

void WinInit()
{
	hLine(0,0,23,"|");
	hLine(79,1,23,"|");
	hLine(24,0,9,"|");
	vLine(0,79,0,"=");
	vLine(0,79,12,".");
	vLine(0,79,20,"=");
	vLine(0,78,24,"=");
	vLine(0,79,10,"=");
	
	mvprintw(11,2," Nr ");
	mvprintw(11,8," Call ");
	mvprintw(11,18," RST out ");
	mvprintw(11,29," RST_Nr in ");
	mvprintw(11,41," Locator ");
	mvprintw(11,54," UTC ");
	mvprintw(11,62," Dist./km ");
	mvprintw(11,71," Direct.");
	mvprintw(0,8," Nummer ");
	mvprintw(0,28," Nr ");
	mvprintw(0,36," Call ");
	mvprintw(0,61," RST_Nr in ");
	mvprintw(0,46," Locator ");
	mvprintw(20,2," StatusWin ");


	refresh();
}

void vLine(int x1,int x2,int y,char *s)
{
int i;
	for(i=x1;i<=x2;i++)
		mvprintw(y,i,"%s",s);
		refresh();
}

void hLine(int x,int y1,int y2,char *s)
{
int i;
	for(i=y1;i<=y2;i++)
		mvprintw(i,x,"%s",s);
}

/**************************   Status Window ****************************/

void kilometers(WINDOW *Window, int total, int number)
{
	mvwprintw(Window,0,43,"total kilometers   : %d", total);
	mvwprintw(Window,1,43,"average kilometers : %d", total/number);
	wrefresh(Window);
}	

/*********************** print numbers into the window *****************/

void printnr(WINDOW *Window1, WINDOW *Window2, WINDOW *Window3, int s)
{
char num[100], num2[100], dummy[3];
int i=0,j,k=0,l=0;
	sprintf(num,"%d\n",s);
	for(k=0;num[k]!='\n';k++);
	i=k;
	while(i!=0){
		sprintf(dummy,"%c\n",num[--i]);
		j=atoi(dummy);
		assign(num2, j);
		switch(l++){
			case 0:
				number2win(Window3,num2);
				break;
			case 1:
				number2win(Window2,num2);
				break;
			case 2:
				number2win(Window1,num2);
				break;
		}	
	}
	if(l==1){
		assign(num2,0);
		number2win(Window2,num2);
		l++;
	}
	if(l==2){              
		assign(num2,0);
		number2win(Window1,num2);
	}         	
		
	
}		

void assign(char *s, int i)
{
	switch (i) {
		case 1: 
			strcpy(s,one);
			break;
		case 2:
			strcpy(s,two);
			break;
		case 3:
			strcpy(s,three);
			break;
		case 4: 
			strcpy(s,four);
			break;
		case 5:
			strcpy(s,five);
			break;
		case 6:
			strcpy(s,six);
			break;
		case 7: 
			strcpy(s,seven);
			break;
		case 8:
			strcpy(s,eight);
			break;
		case 9:
			strcpy(s,nine);
			break;
		case 0:
			strcpy(s,zero);
			break;
	}
}

void number2win(WINDOW *Window,char *s)
{
				wclear(Window);
				mvwprintw(Window,0,0,s);
				wrefresh(Window);
}
